Only in b: build
diff -ur a/CMakeLists.txt b/CMakeLists.txt
--- a/CMakeLists.txt	2020-06-23 11:24:44.753679393 +0200
+++ b/CMakeLists.txt	2020-06-22 18:30:10.419035968 +0200
@@ -1,4 +1,6 @@
 # Default install location. Must be set here, before setting the project.
+set(CMAKE_SKIP_RPATH TRUE)
+
 if (NOT DEFINED CMAKE_INSTALL_PREFIX)
     set(CMAKE_INSTALL_PREFIX ${CMAKE_BINARY_DIR}/install CACHE PATH "" FORCE)
     set(LOCAL_INSTALL "ON")
@@ -140,7 +142,7 @@
 pkg_check_modules(GIO_DEPS REQUIRED gio-2.0 gio-unix-2.0)
 pkg_check_modules(IMG_DEPS REQUIRED gdk-pixbuf-2.0 libexif)
 pkg_check_modules(UNITY_API_DEPS REQUIRED libunity-api)
-pkg_check_modules(APPARMOR_DEPS REQUIRED libapparmor)
+# pkg_check_modules(APPARMOR_DEPS REQUIRED libapparmor)
 pkg_check_modules(TAGLIB_DEPS REQUIRED taglib)
 pkg_check_modules(CACHE_DEPS REQUIRED libpersistent-cache-cpp)
 
Only in b: downloadpkg.sh
Only in b/.git: COMMIT_EDITMSG
diff -ur a/.git/hooks/fsmonitor-watchman.sample b/.git/hooks/fsmonitor-watchman.sample
--- a/.git/hooks/fsmonitor-watchman.sample	2020-06-23 11:24:18.263879390 +0200
+++ b/.git/hooks/fsmonitor-watchman.sample	2020-05-31 17:17:36.232080488 +0200
@@ -8,166 +8,102 @@
 # (https://facebook.github.io/watchman/) with git to speed up detecting
 # new and modified files.
 #
-# The hook is passed a version (currently 2) and last update token
-# formatted as a string and outputs to stdout a new update token and
-# all files that have been modified since the update token. Paths must
-# be relative to the root of the working tree and separated by a single NUL.
+# The hook is passed a version (currently 1) and a time in nanoseconds
+# formatted as a string and outputs to stdout all files that have been
+# modified since the given time. Paths must be relative to the root of
+# the working tree and separated by a single NUL.
 #
 # To enable this hook, rename this file to "query-watchman" and set
 # 'git config core.fsmonitor .git/hooks/query-watchman'
 #
-my ($version, $last_update_token) = @ARGV;
-
-# Uncomment for debugging
-# print STDERR "$0 $version $last_update_token\n";
+my ($version, $time) = @ARGV;
 
 # Check the hook interface version
-if ($version ne 2) {
+
+if ($version == 1) {
+	# convert nanoseconds to seconds
+	# subtract one second to make sure watchman will return all changes
+	$time = int ($time / 1000000000) - 1;
+} else {
 	die "Unsupported query-fsmonitor hook version '$version'.\n" .
 	    "Falling back to scanning...\n";
 }
 
-my $git_work_tree = get_working_dir();
+my $git_work_tree;
+if ($^O =~ 'msys' || $^O =~ 'cygwin') {
+	$git_work_tree = Win32::GetCwd();
+	$git_work_tree =~ tr/\\/\//;
+} else {
+	require Cwd;
+	$git_work_tree = Cwd::cwd();
+}
 
 my $retry = 1;
 
-my $json_pkg;
-eval {
-	require JSON::XS;
-	$json_pkg = "JSON::XS";
-	1;
-} or do {
-	require JSON::PP;
-	$json_pkg = "JSON::PP";
-};
-
 launch_watchman();
 
 sub launch_watchman {
-	my $o = watchman_query();
-	if (is_work_tree_watched($o)) {
-		output_result($o->{clock}, @{$o->{files}});
-	}
-}
-
-sub output_result {
-	my ($clockid, @files) = @_;
-
-	# Uncomment for debugging watchman output
-	# open (my $fh, ">", ".git/watchman-output.out");
-	# binmode $fh, ":utf8";
-	# print $fh "$clockid\n@files\n";
-	# close $fh;
 
-	binmode STDOUT, ":utf8";
-	print $clockid;
-	print "\0";
-	local $, = "\0";
-	print @files;
-}
-
-sub watchman_clock {
-	my $response = qx/watchman clock "$git_work_tree"/;
-	die "Failed to get clock id on '$git_work_tree'.\n" .
-		"Falling back to scanning...\n" if $? != 0;
-
-	return $json_pkg->new->utf8->decode($response);
-}
-
-sub watchman_query {
 	my $pid = open2(\*CHLD_OUT, \*CHLD_IN, 'watchman -j --no-pretty')
-	or die "open2() failed: $!\n" .
-	"Falling back to scanning...\n";
+	    or die "open2() failed: $!\n" .
+	    "Falling back to scanning...\n";
 
 	# In the query expression below we're asking for names of files that
-	# changed since $last_update_token but not from the .git folder.
+	# changed since $time but were not transient (ie created after
+	# $time but no longer exist).
 	#
 	# To accomplish this, we're using the "since" generator to use the
 	# recency index to select candidate nodes and "fields" to limit the
-	# output to file names only. Then we're using the "expression" term to
-	# further constrain the results.
-	if (substr($last_update_token, 0, 1) eq "c") {
-		$last_update_token = "\"$last_update_token\"";
-	}
+	# output to file names only.
+
 	my $query = <<"	END";
 		["query", "$git_work_tree", {
-			"since": $last_update_token,
-			"fields": ["name"],
-			"expression": ["not", ["dirname", ".git"]]
+			"since": $time,
+			"fields": ["name"]
 		}]
 	END
 
-	# Uncomment for debugging the watchman query
-	# open (my $fh, ">", ".git/watchman-query.json");
-	# print $fh $query;
-	# close $fh;
-
 	print CHLD_IN $query;
 	close CHLD_IN;
 	my $response = do {local $/; <CHLD_OUT>};
 
-	# Uncomment for debugging the watch response
-	# open ($fh, ">", ".git/watchman-response.json");
-	# print $fh $response;
-	# close $fh;
-
 	die "Watchman: command returned no output.\n" .
-	"Falling back to scanning...\n" if $response eq "";
+	    "Falling back to scanning...\n" if $response eq "";
 	die "Watchman: command returned invalid output: $response\n" .
-	"Falling back to scanning...\n" unless $response =~ /^\{/;
+	    "Falling back to scanning...\n" unless $response =~ /^\{/;
 
-	return $json_pkg->new->utf8->decode($response);
-}
+	my $json_pkg;
+	eval {
+		require JSON::XS;
+		$json_pkg = "JSON::XS";
+		1;
+	} or do {
+		require JSON::PP;
+		$json_pkg = "JSON::PP";
+	};
+
+	my $o = $json_pkg->new->utf8->decode($response);
 
-sub is_work_tree_watched {
-	my ($output) = @_;
-	my $error = $output->{error};
-	if ($retry > 0 and $error and $error =~ m/unable to resolve root .* directory (.*) is not watched/) {
+	if ($retry > 0 and $o->{error} and $o->{error} =~ m/unable to resolve root .* directory (.*) is not watched/) {
+		print STDERR "Adding '$git_work_tree' to watchman's watch list.\n";
 		$retry--;
-		my $response = qx/watchman watch "$git_work_tree"/;
+		qx/watchman watch "$git_work_tree"/;
 		die "Failed to make watchman watch '$git_work_tree'.\n" .
 		    "Falling back to scanning...\n" if $? != 0;
-		$output = $json_pkg->new->utf8->decode($response);
-		$error = $output->{error};
-		die "Watchman: $error.\n" .
-		"Falling back to scanning...\n" if $error;
-
-		# Uncomment for debugging watchman output
-		# open (my $fh, ">", ".git/watchman-output.out");
-		# close $fh;
 
 		# Watchman will always return all files on the first query so
 		# return the fast "everything is dirty" flag to git and do the
 		# Watchman query just to get it over with now so we won't pay
 		# the cost in git to look up each individual file.
-		my $o = watchman_clock();
-		$error = $output->{error};
-
-		die "Watchman: $error.\n" .
-		"Falling back to scanning...\n" if $error;
-
-		output_result($o->{clock}, ("/"));
-		$last_update_token = $o->{clock};
-
+		print "/\0";
 		eval { launch_watchman() };
-		return 0;
+		exit 0;
 	}
 
-	die "Watchman: $error.\n" .
-	"Falling back to scanning...\n" if $error;
-
-	return 1;
-}
+	die "Watchman: $o->{error}.\n" .
+	    "Falling back to scanning...\n" if $o->{error};
 
-sub get_working_dir {
-	my $working_dir;
-	if ($^O =~ 'msys' || $^O =~ 'cygwin') {
-		$working_dir = Win32::GetCwd();
-		$working_dir =~ tr/\\/\//;
-	} else {
-		require Cwd;
-		$working_dir = Cwd::cwd();
-	}
-
-	return $working_dir;
+	binmode STDOUT, ":utf8";
+	local $, = "\0";
+	print @{$o->{files}};
 }
diff -ur a/.git/hooks/pre-commit.sample b/.git/hooks/pre-commit.sample
--- a/.git/hooks/pre-commit.sample	2020-06-23 11:24:18.263879390 +0200
+++ b/.git/hooks/pre-commit.sample	2020-05-31 17:17:36.233080485 +0200
@@ -16,7 +16,7 @@
 fi
 
 # If you want to allow non-ASCII filenames set this variable to true.
-allownonascii=$(git config --type=bool hooks.allownonascii)
+allownonascii=$(git config --bool hooks.allownonascii)
 
 # Redirect output to stderr.
 exec 1>&2
diff -ur a/.git/hooks/update.sample b/.git/hooks/update.sample
--- a/.git/hooks/update.sample	2020-06-23 11:24:18.263879390 +0200
+++ b/.git/hooks/update.sample	2020-05-31 17:17:36.233080485 +0200
@@ -43,11 +43,11 @@
 fi
 
 # --- Config
-allowunannotated=$(git config --type=bool hooks.allowunannotated)
-allowdeletebranch=$(git config --type=bool hooks.allowdeletebranch)
-denycreatebranch=$(git config --type=bool hooks.denycreatebranch)
-allowdeletetag=$(git config --type=bool hooks.allowdeletetag)
-allowmodifytag=$(git config --type=bool hooks.allowmodifytag)
+allowunannotated=$(git config --bool hooks.allowunannotated)
+allowdeletebranch=$(git config --bool hooks.allowdeletebranch)
+denycreatebranch=$(git config --bool hooks.denycreatebranch)
+allowdeletetag=$(git config --bool hooks.allowdeletetag)
+allowmodifytag=$(git config --bool hooks.allowmodifytag)
 
 # check for no description
 projectdesc=$(sed -e '1q' "$GIT_DIR/description")
Binary files a/.git/index and b/.git/index differ
diff -ur a/.git/logs/HEAD b/.git/logs/HEAD
--- a/.git/logs/HEAD	2020-06-23 11:24:18.300879111 +0200
+++ b/.git/logs/HEAD	2020-06-01 21:24:45.431230033 +0200
@@ -1 +1,4 @@
-0000000000000000000000000000000000000000 a4387b8ff1e70261d73020e19d28af2136a68946 Erlend <me@erlend.io> 1592903565 +0200	clone: from https://github.com/ubports/thumbnailer.git
+0000000000000000000000000000000000000000 a4387b8ff1e70261d73020e19d28af2136a68946 Erlend <me@erlend.io> 1590938262 +0200	clone: from https://github.com/ubports/thumbnailer.git
+a4387b8ff1e70261d73020e19d28af2136a68946 9c4720c5468dfdd2b84726eb5a04313956d7bfb4 Erlend <me@erlend.io> 1591038018 +0200	commit: disable apparmor
+9c4720c5468dfdd2b84726eb5a04313956d7bfb4 574ba477116cc252da5ea75a8345894826787bba Erlend <me@erlend.io> 1591038980 +0200	commit: fix rpath
+574ba477116cc252da5ea75a8345894826787bba f3bd4eb0149425addcf40a24593dd6b2a82b85b1 Erlend <me@erlend.io> 1591039485 +0200	commit: fixed rpath in qml plugin
diff -ur a/.git/logs/refs/heads/xenial b/.git/logs/refs/heads/xenial
--- a/.git/logs/refs/heads/xenial	2020-06-23 11:24:18.300879111 +0200
+++ b/.git/logs/refs/heads/xenial	2020-06-01 21:24:45.431230033 +0200
@@ -1 +1,4 @@
-0000000000000000000000000000000000000000 a4387b8ff1e70261d73020e19d28af2136a68946 Erlend <me@erlend.io> 1592903565 +0200	clone: from https://github.com/ubports/thumbnailer.git
+0000000000000000000000000000000000000000 a4387b8ff1e70261d73020e19d28af2136a68946 Erlend <me@erlend.io> 1590938262 +0200	clone: from https://github.com/ubports/thumbnailer.git
+a4387b8ff1e70261d73020e19d28af2136a68946 9c4720c5468dfdd2b84726eb5a04313956d7bfb4 Erlend <me@erlend.io> 1591038018 +0200	commit: disable apparmor
+9c4720c5468dfdd2b84726eb5a04313956d7bfb4 574ba477116cc252da5ea75a8345894826787bba Erlend <me@erlend.io> 1591038980 +0200	commit: fix rpath
+574ba477116cc252da5ea75a8345894826787bba f3bd4eb0149425addcf40a24593dd6b2a82b85b1 Erlend <me@erlend.io> 1591039485 +0200	commit: fixed rpath in qml plugin
diff -ur a/.git/logs/refs/remotes/origin/HEAD b/.git/logs/refs/remotes/origin/HEAD
--- a/.git/logs/refs/remotes/origin/HEAD	2020-06-23 11:24:18.300879111 +0200
+++ b/.git/logs/refs/remotes/origin/HEAD	2020-05-31 17:17:42.424065001 +0200
@@ -1 +1 @@
-0000000000000000000000000000000000000000 a4387b8ff1e70261d73020e19d28af2136a68946 Erlend <me@erlend.io> 1592903565 +0200	clone: from https://github.com/ubports/thumbnailer.git
+0000000000000000000000000000000000000000 a4387b8ff1e70261d73020e19d28af2136a68946 Erlend <me@erlend.io> 1590938262 +0200	clone: from https://github.com/ubports/thumbnailer.git
Only in b/.git/objects: 1a
Only in b/.git/objects: 20
Only in b/.git/objects: 2e
Only in b/.git/objects: 44
Only in b/.git/objects: 4c
Only in b/.git/objects: 57
Only in b/.git/objects: 64
Only in b/.git/objects: 71
Only in b/.git/objects: 9c
Only in b/.git/objects: ba
Only in b/.git/objects: c2
Only in b/.git/objects: e6
Only in b/.git/objects: f1
Only in b/.git/objects: f3
Only in b/.git/objects: f4
diff -ur a/.git/refs/heads/xenial b/.git/refs/heads/xenial
--- a/.git/refs/heads/xenial	2020-06-23 11:24:18.264879382 +0200
+++ b/.git/refs/heads/xenial	2020-06-01 21:24:45.431230033 +0200
@@ -1 +1 @@
-a4387b8ff1e70261d73020e19d28af2136a68946
+f3bd4eb0149425addcf40a24593dd6b2a82b85b1
diff -ur a/include/internal/raii.h b/include/internal/raii.h
--- a/include/internal/raii.h	2020-06-23 11:24:18.303879088 +0200
+++ b/include/internal/raii.h	2020-06-23 10:20:20.867821372 +0200
@@ -33,19 +33,12 @@
 namespace internal
 {
 
-auto do_close = [](int fd)
-{
-    if (fd >= 0)
-    {
-        ::close(fd);
-    }
-};
+auto extern do_close = [](int fd);
+
 typedef unity::util::ResourcePtr<int, decltype(do_close)> FdPtr;
 
-auto do_unlink = [](std::string const& filename)
-{
-    ::unlink(filename.c_str());
-};
+auto extern do_unlink = [](std::string const& filename);
+
 typedef unity::util::ResourcePtr<std::string, decltype(do_unlink)> UnlinkPtr;
 
 }  // namespace internal
Only in b: .kdev4
Only in b: patchit
diff -ur a/plugins/Ubuntu/Thumbnailer.0.1/CMakeLists.txt b/plugins/Ubuntu/Thumbnailer.0.1/CMakeLists.txt
--- a/plugins/Ubuntu/Thumbnailer.0.1/CMakeLists.txt	2020-06-23 11:24:18.304879080 +0200
+++ b/plugins/Ubuntu/Thumbnailer.0.1/CMakeLists.txt	2020-06-01 21:23:22.646757552 +0200
@@ -10,7 +10,7 @@
   )
 set_target_properties(thumbnailer-qml-static PROPERTIES AUTOMOC TRUE)
 qt5_use_modules(thumbnailer-qml-static Qml Quick)
-target_link_libraries(thumbnailer-qml-static ${LIBTHUMBNAILER_QT} Qt5::Qml Qt5::Quick)
+target_link_libraries(thumbnailer-qml-static thumbnailer-qt Qt5::Qml Qt5::Quick)
 
 add_library(thumbnailer-qml MODULE
   plugin.cpp
Only in a/src: check_access.cpp.rej
Only in a/src/service: credentialscache.cpp.rej
diff -ur a/src/service/handler.cpp b/src/service/handler.cpp
--- a/src/service/handler.cpp	2020-06-23 11:24:18.306879065 +0200
+++ b/src/service/handler.cpp	2020-06-23 10:19:49.571025622 +0200
@@ -33,6 +33,37 @@
 #include <sys/types.h>
 #include <unistd.h>
 
+namespace unity
+{
+
+namespace thumbnailer
+{
+
+namespace internal
+{
+
+auto do_close = [](int fd)
+{
+    if (fd >= 0)
+    {
+        ::close(fd);
+    }
+};
+
+auto do_unlink = [](std::string const& filename)
+{
+    ::unlink(filename.c_str());
+};
+
+
+}  // namespace internal
+
+}  // namespace thumbnailer
+
+}  // namespace unity
+
+
+
 using namespace std;
 using namespace unity::thumbnailer::internal;
 
Only in b: thumbnailer.kdev4
